
#include <nds.h>
#include "quad.h"

extern unsigned char _binary_tile_r_pcx_start[];

/**
 * This function works
 */
static void quad_me ()
{
	glBegin (GL_QUADS);

	glTexCoord2f (0, 0);
	glVertex3v16 (0, TILE_HEIGHT, 0);

	glTexCoord2f (0, 1);
	glVertex3v16 (0, 0, 0);

	glTexCoord2f (1, 1);
	glVertex3v16 (TILE_WIDTH, 0, 0);

	glTexCoord2f (1, 0);
	glVertex3v16 (TILE_WIDTH, TILE_HEIGHT, 0);

	glEnd ();
}

int main (int argc, char *argv[])
{
	powerON(POWER_ALL);
	
	videoSetMode (MODE_0_3D);
	vramSetBankA (VRAM_A_TEXTURE);

	irqInit();
	irqSet(IRQ_VBLANK, 0);

	glInit ();
	glEnable (GL_TEXTURE_2D);

	glClearColor (31, 31, 31, 31);
	glClearDepth (GL_MAX_DEPTH);

	glViewport (0, 0, 255, 191);
	
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glOrthof32 (0, 256, 0, 192, -1, 1);

	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity();

	int textures[1];
    glGenTextures (1, textures);
    sImage tile;
	loadPCX (_binary_tile_r_pcx_start, &tile);
	image8to16trans (&tile, 2);
	glBindTexture (GL_TEXTURE_2D, textures[0]);
	glTexImage2D (0, 0, GL_RGBA, TEXTURE_SIZE_32, TEXTURE_SIZE_16, 0, TEXGEN_TEXCOORD, tile.image.data16);
	imageDestroy (&tile);

    glBindTexture (GL_TEXTURE_2D, textures[0]);
	glPolyFmt (POLY_ALPHA (31) | POLY_CULL_NONE);
	glColor3f (1.0, 1.0, 1.0);

	while (true) {
		for (int row = 0; row < 12; ++row) {
			for (int col = 0; col < 12; ++col) {
				int s = (col - row) * TILE_WIDTH/2;
				int t = (col + row) * TILE_HEIGHT/2;

				glPushMatrix ();
				glTranslate3f32 (s, t, 0);
				if ((row + col) % 2)
					quad_me_not ();
				else
					quad_me ();
				glPopMatrix (1);
			}
		}

		glFlush (0);
		swiWaitForVBlank();
	}
}

// vim: noet ts=4 sts=0
